﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Collections;
using System.Xml;

namespace SSRS_Plus
{
    public partial class frmServers : Form
    {
        SortedList alServers;
        bool boolAddNewFlag = false;
        clsServers ActiveServer;

        public frmServers()
        {
            InitializeComponent();
        }

        private void lblServerName_Click(object sender, EventArgs e)
        {

        }

        private void frmServers_Load(object sender, EventArgs e)
        {
            
            //MessageBox.Show(Security.Encrypt("Asim"));

            ClearTextboxes();
            LoadServerDetails();
            EnabledControls(true);
        }

        private void LoadServerDetails()
        {
            try
            {
                alServers = new SortedList();
                lstServers.Items.Clear();

                clsServers Srv;

                ServersSection SerSec = (ServersSection)ConfigurationManager.GetSection("ServersSection");

                int i = 0;

                while (i < SerSec.servergroups.Count)
                {
                    Srv = new clsServers();
                    Srv = (clsServers)SerSec.servergroups[i];

                    //Srv.ServerName = Srv.ServerName;
                    //Srv.ServerURL = new Uri(System.Configuration.ConfigurationSettings.AppSettings[Srv.ServerName]);

                    alServers.Add(Srv.ServerName, Srv);

                    lstServers.Items.Add(Srv.ServerName);

                    i++;
                }

                if (lstServers.Items.Count > 0)
                {
                    lstServers.SelectedIndex = 0;
                }
            }
            catch
            {

            }
        }

        private void EnabledControls(bool Flag)
        {
            try
            {
                lstServers.Enabled = Flag;

                txtServerName.ReadOnly = Flag;
                txtServerURL.ReadOnly = Flag;

                if (ckbWindowsCredential.Checked == true)
                {
                    txtDomain.ReadOnly = true;
                    txtUserName.ReadOnly = true;
                    txtPassword.ReadOnly = true;
                }
                else
                {
                    txtDomain.ReadOnly = Flag;
                    txtUserName.ReadOnly = Flag;
                    txtPassword.ReadOnly = Flag;
                }

                btnNew.Enabled = Flag;
                if (lstServers.Items.Count == 0)
                {
                    btnEdit.Enabled = false;
                    btnDelete.Enabled = false;
                }
                else
                {
                    btnEdit.Enabled = Flag;
                    btnDelete.Enabled = Flag;
                }
                btnSave.Enabled = !Flag;
                btnCancel.Enabled = !Flag;

                ckbWindowsCredential.Enabled = !Flag;
            }
            catch { }
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            boolAddNewFlag = true;
            ClearTextboxes();
            EnabledControls(false);
        }

        private void ClearTextboxes()
        {
            txtServerName.Text = "";
            txtServerURL.Text = "";
            txtDomain.Text = "";
            txtUserName.Text = "";
            txtPassword.Text = "";
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            ClearTextboxes();
            LoadServerDetails();
            EnabledControls(true);
            boolAddNewFlag = false;
        }

        private void GetServerDetail(string strServer)
        {
            ActiveServer = new clsServers();
            ActiveServer = (clsServers)alServers[strServer];

            txtServerName.Text = ActiveServer.ServerName;
            txtServerURL.Text = ActiveServer.ServerURL.ToString();
            txtUserName.Text = ActiveServer.UserName;
            txtPassword.Text = ActiveServer.Password;
            txtDomain.Text = ActiveServer.Domain;

            ckbWindowsCredential.Checked = ActiveServer.WindowsAuthentication;
        }

        private void lstServers_SelectedIndexChanged(object sender, EventArgs e)
        {
            GetServerDetail(lstServers.Text);
        }

        private bool ValidateControl()
        {
            if (txtServerName.Text.Trim() == "")
            {
                MessageBox.Show("Server Name can not be empty!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                txtServerName.Focus();
                return false;
            }

            if (txtServerURL.Text.Trim() == "")
            {
                MessageBox.Show("SSRS Web Service URL can not be empty!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                txtServerURL.Focus();
                return false;
            }

            if (!ckbWindowsCredential.Checked)
            {
                if (txtDomain.Text.Trim() == "")
                {
                    MessageBox.Show("Domain Name can not be empty!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    txtDomain.Focus();
                    return false;
                }

                if (txtUserName.Text.Trim() == "")
                {
                    MessageBox.Show("User Name can not be empty!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    txtUserName.Focus();
                    return false;
                }

                if (txtPassword.Text.Trim() == "")
                {
                    MessageBox.Show("Password can not be empty!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    txtPassword.Focus();
                    return false;
                }
            }

            if (boolAddNewFlag == true)
            {
                if (alServers[txtServerName.Text.Trim()] != null)
                {
                    MessageBox.Show("Server with same name already exists! Please enter diffrent name!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    txtServerName.Focus();
                    return false;
                }
            }
            else
            {
                foreach (string strServer in alServers.Keys)
                {
                    if (strServer != ActiveServer.ServerName && strServer == txtServerName.Text.Trim())
                    {
                        MessageBox.Show("Server with same name already exists! Please enter diffrent name!", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        txtServerName.Focus();
                        return false;
                    }
                }
            }

            return true;
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            boolAddNewFlag = false;
            EnabledControls(false);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            try
            {
                if (ValidateControl())
                {
                    AddModifyServer();
                    boolAddNewFlag = false;
                    EnabledControls(true);
                    LoadServerDetails();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        private void AddModifyServer()
        {
            clsServers UpdateServer = new clsServers();

            UpdateServer.ServerName = txtServerName.Text.Trim();
            UpdateServer.ServerURL = new Uri(txtServerURL.Text.Trim());
            UpdateServer.WindowsAuthentication = ckbWindowsCredential.Checked;
            UpdateServer.UserName = txtUserName.Text.Trim();
            UpdateServer.Domain = txtDomain.Text.Trim();
            UpdateServer.Password =  Security.Encrypt(txtPassword.Text.Trim());

            XmlDocument xDoc = new XmlDocument();
            xDoc.Load(AppDomain.CurrentDomain.SetupInformation.ConfigurationFile);

            if (boolAddNewFlag)
            {
                XmlNode xn = xDoc.SelectSingleNode("configuration/ServersSection/servergroups");

                XmlElement xnNew = xDoc.CreateElement("server", null);

                xnNew.SetAttribute("ServerName", UpdateServer.ServerName);
                xnNew.SetAttribute("ServerURL", UpdateServer.ServerURL.ToString());
                xnNew.SetAttribute("WindowsAuthentication", UpdateServer.WindowsAuthentication.ToString());
                xnNew.SetAttribute("Domain", UpdateServer.Domain.ToString());
                xnNew.SetAttribute("UserName", UpdateServer.UserName);
                xnNew.SetAttribute("Password", UpdateServer.Password.ToString());

                xn.AppendChild(xnNew);
            }
            else
            {
                foreach (XmlNode xn in xDoc.SelectNodes("configuration/ServersSection/servergroups/server"))
                {
                    if (xn.Attributes[0].Value == ActiveServer.ServerName)
                    {
                        xn.Attributes[0].Value = UpdateServer.ServerName;
                        xn.Attributes[1].Value = UpdateServer.ServerURL.ToString();

                        xn.Attributes[2].Value = UpdateServer.WindowsAuthentication.ToString();
                        xn.Attributes[3].Value = UpdateServer.Domain.ToString();
                        xn.Attributes[4].Value = UpdateServer.UserName.ToString();
                        xn.Attributes[5].Value = UpdateServer.Password.ToString();


                        break;
                    }
                }
            }

            xDoc.Save(AppDomain.CurrentDomain.SetupInformation.ConfigurationFile);

            ConfigurationManager.RefreshSection("ServersSection");
        }

        private void ckbWindowsCredential_CheckedChanged(object sender, EventArgs e)
        {
            if (btnNew.Enabled == false)
            {
                txtDomain.Text = "";
                txtPassword.Text = "";
                txtUserName.Text = "";

                txtDomain.ReadOnly = ckbWindowsCredential.Checked;
                txtUserName.ReadOnly = ckbWindowsCredential.Checked;
                txtPassword.ReadOnly = ckbWindowsCredential.Checked;
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure want to delete " + lstServers.Text + " Server?", "Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) == DialogResult.Yes)
            {
                XmlDocument xDoc = new XmlDocument();
                xDoc.Load(AppDomain.CurrentDomain.SetupInformation.ConfigurationFile);

                foreach (XmlNode xn in xDoc.SelectNodes("configuration/ServersSection/servergroups/server"))
                {
                    if (xn.Attributes[0].Value == ActiveServer.ServerName)
                    {
                        xDoc.SelectSingleNode("configuration/ServersSection/servergroups").RemoveChild(xn);
                        break;
                    }
                }

                xDoc.Save(AppDomain.CurrentDomain.SetupInformation.ConfigurationFile);
                ConfigurationManager.RefreshSection("ServersSection");
                ClearTextboxes();
                LoadServerDetails();
                EnabledControls(true);
            }
        }
    }
}
